package exocomp

import (
	"fmt"
	"log"
	"os"
	"strings"
	"time"

	gitlab "github.com/xanzy/go-gitlab"
)

type Gitlab struct {
	client *gitlab.Client
}

// Projects will retrieve a list of gitlab projects.
// When `onlyMembershipRepos` set to true it limits projects
// to projects that the current user is a member of.
func (g Gitlab) Projects(filter GitlabProjectsOptions) ([]*gitlab.Project, error) {
	all := []*gitlab.Project{}

	opt := &gitlab.ListProjectsOptions{
		ListOptions: gitlab.ListOptions{
			PerPage: 100,
			Page:    1,
		},
		Membership: gitlab.Ptr(filter.OnlyMembershipRepos),
		Archived:   gitlab.Ptr(false),
	}

	if filter.LimitToProject > 0 {
		// Limit results to projects with IDs greater than the specified ID.
		opt.IDAfter = gitlab.Ptr(filter.LimitToProject - 1)
		// Limit results to projects with IDs less than the specified ID.
		opt.IDBefore = gitlab.Ptr(filter.LimitToProject + 1)
	}

	for {
		projects, _, err := g.client.Projects.ListProjects(opt)
		if err != nil {
			return []*gitlab.Project{}, err
		}

		for _, project := range projects {
			if filter.ExcludePersonalRepos && strings.ToLower(project.Namespace.Kind) == "user" {
				continue
			}
			all = append(all, project)
		}

		if len(projects) != 100 {
			break
		}

		opt.ListOptions.Page++
	}

	return all, nil
}

func (g Gitlab) Groups() ([]*gitlab.Group, error) {
	all := []*gitlab.Group{}

	opt := &gitlab.ListGroupsOptions{
		ListOptions: gitlab.ListOptions{
			PerPage: 100,
			Page:    1,
		},
	}

	for {
		groups, _, err := g.client.Groups.ListGroups(opt)
		if err != nil {
			return nil, err
		}

		all = append(all, groups...)

		if len(groups) != 100 {
			break
		}

		opt.ListOptions.Page++
	}

	return all, nil
}

func (g Gitlab) LookupProjectVariables(project *gitlab.Project) ([]*gitlab.ProjectVariable, error) {
	opt := &gitlab.ListProjectVariablesOptions{}
	projectVariables, response, err := g.client.ProjectVariables.ListVariables(project.ID, opt)
	if err != nil && response.Response.StatusCode == 403 {
		log.Printf("listing project variables failed: %s\n", err)
	}

	return projectVariables, nil
}

func (g Gitlab) LookupGroupVariables(group *gitlab.Group) ([]*gitlab.GroupVariable, error) {
	opt := &gitlab.ListGroupVariablesOptions{}
	groupVariables, response, err := g.client.GroupVariables.ListVariables(group.ID, opt)
	if err != nil && response.Response.StatusCode == 403 {
		log.Printf("listing group variables failed: %s\n", err)
	}

	return groupVariables, nil
}

func (g Gitlab) LookupIssue(project *gitlab.Project, title string) (*gitlab.Issue, error) {
	opt := &gitlab.ListProjectIssuesOptions{
		ListOptions: gitlab.ListOptions{
			PerPage: 1,
			Page:    1,
		},
		Search: gitlab.Ptr(title),
		In:     gitlab.Ptr("title"),
	}

	issues, _, err := g.client.Issues.ListProjectIssues(project.ID, opt)
	if err != nil {
		return nil, err
	}

	if len(issues) == 1 {
		return issues[0], nil
	}

	if len(issues) != 0 {
		return nil, fmt.Errorf("too many issues found")
	}

	return nil, nil
}

func (g Gitlab) CreateIssue(project *gitlab.Project, issue IssueState, issueLabel string) (*gitlab.Issue, error) {
	opt := &gitlab.CreateIssueOptions{
		Title:       gitlab.Ptr(issue.Title),
		Description: gitlab.Ptr(issue.Body),
		Labels:      &gitlab.LabelOptions{"exocomp", issueLabel},
	}

	newIssue, _, err := g.client.Issues.CreateIssue(project.ID, opt)
	return newIssue, err
}

func (g Gitlab) UpdateIssue(project *gitlab.Project, issueId int, issue IssueState, issueLabel string) (*gitlab.Issue, error) {
	stateEvent := "close"
	if issue.Open {
		stateEvent = "reopen"
	}

	opt := &gitlab.UpdateIssueOptions{
		Title:       gitlab.Ptr(issue.Title),
		Description: gitlab.Ptr(issue.Body),
		Labels:      &gitlab.LabelOptions{"exocomp", issueLabel},
		StateEvent:  gitlab.Ptr(stateEvent),
	}

	newIssue, _, err := g.client.Issues.UpdateIssue(project.ID, issueId, opt)
	return newIssue, err
}

func (g Gitlab) LookupMergeRequest(project *gitlab.Project, sourceBranch, targetBranch string) (*gitlab.MergeRequest, error) {
	state := "opened"
	opt := &gitlab.ListProjectMergeRequestsOptions{
		ListOptions: gitlab.ListOptions{
			PerPage: 1,
			Page:    1,
		},
		SourceBranch: &sourceBranch,
		TargetBranch: &targetBranch,
		State:        &state,
	}

	mergeRequests, _, err := g.client.MergeRequests.ListProjectMergeRequests(project.ID, opt)
	if err != nil {
		return nil, err
	}

	if len(mergeRequests) == 1 {
		return mergeRequests[0], nil
	}

	if len(mergeRequests) != 0 {
		return nil, fmt.Errorf("too many merge requests found")
	}

	return nil, nil
}

func (g Gitlab) CreateMergeRequest(project *gitlab.Project, cc CodeChange) (*gitlab.MergeRequest, error) {
	title := cc.MergeRequestTitle()
	description := cc.MergeRequestBody()
	sourceBranch := cc.BranchName()
	targetBranch := project.DefaultBranch

	descriptionPrefix := "This Merge Request was generated by Exocomp.\n\n"

	if descriptionPrefixFromEnv, environmentVariableIsSet := os.LookupEnv("EXOCOMP_MERGE_REQUEST_DESCRIPTION_PREFIX"); environmentVariableIsSet {
		descriptionPrefix = descriptionPrefixFromEnv
	}

	description = descriptionPrefix + description
	removeSourceBranch := true
	allowCollaboration := true
	opt := &gitlab.CreateMergeRequestOptions{
		Title:              &title,
		Description:        &description,
		Labels:             &gitlab.LabelOptions{"exocomp", "bot", cc.Name()},
		SourceBranch:       &sourceBranch,
		TargetBranch:       &targetBranch,
		RemoveSourceBranch: &removeSourceBranch,
		AllowCollaboration: &allowCollaboration,
	}

	mr, _, err := g.client.MergeRequests.CreateMergeRequest(project.ID, opt)
	return mr, err
}

func (g Gitlab) ReloadMergeRequest(project *gitlab.Project, mr *gitlab.MergeRequest) (*gitlab.MergeRequest, error) {
	mr, _, err := g.client.MergeRequests.GetMergeRequest(project.ID, mr.IID, &gitlab.GetMergeRequestsOptions{})
	if err != nil {
		return nil, err
	}

	return mr, nil
}

func (g Gitlab) EnableGitlabAutomerge(project *gitlab.Project, mr *gitlab.MergeRequest, disableAutomergeFlag bool) (*gitlab.MergeRequest, error) {
	if disableAutomergeFlag {
		log.Println("skip automerge because the `--disable-automerge` flag is set to `true`")
		return mr, nil
	}

	if mr.Pipeline == nil {
		log.Println("mr.Pipeline is nil")
		return mr, nil
	}

	if mr.Pipeline.Status == "failed" {
		log.Println("mr.Pipeline.Status equals 'failed'")
		return mr, nil
	}

	if mr.Pipeline.Status == "failed" {
		log.Println("mr.Pipeline.Status equals 'failed'")
		return mr, nil
	}

	var err error
	for mr.DetailedMergeStatus == "checking" {
		log.Println("mergerequest status is 'checking'. reloading mergerequest from gitlab")
		time.Sleep(5 * time.Second)
		mr, err = g.ReloadMergeRequest(project, mr)
		if err != nil {
			return nil, err
		}
	}

	udpateOpt := &gitlab.AcceptMergeRequestOptions{
		MergeWhenPipelineSucceeds: gitlab.Ptr(true),
	}

	mr, _, err = g.client.MergeRequests.AcceptMergeRequest(project.ID, mr.IID, udpateOpt)
	if err != nil {
		return nil, err
	}

	return mr, nil
}
